﻿Type=Class
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

#Event: Info(Results As Map)
#Event: Error(ErrorMessage As String)

Private Sub Class_Globals
	
	       Private http As OkHttpClient
								Private req As OkHttpRequest
								Private Parser As SaxParser
								Private InfoMap As Map
								Private cParent As Activity
								Private cCallback As Object
								Private cEventName As String
								
								Private Country, CountryCode, Region, RegionName, City, ZIP, Latitude, Longitude, TimeZone, ISP, Org, ASCode, IP	As String
								Private SpeedWebView As WebView
								
								Private IsSpeedShow As Boolean	

End Sub

'Initializes the IPInfo library.
'Parent: Activity (Required).
'Callback: Me (Required).
'EventName: Prefix to be used on the event responses.
Public Sub Initialize(Parent As Activity, Callback As Object, EventName As String)
	
     		cParent = Parent
							cCallback = Callback
							cEventName = EventName
							
							http.Initialize("http")
							Parser.Initialize
							InfoMap.Initialize	
       SpeedWebView.Initialize("MeasureSpeed")
							SpeedWebView.ZoomEnabled = False
							SpeedWebView.Visible = False
							cParent.AddView(SpeedWebView, 0dip, 0dip, 100%x, 100%y)
														
End Sub

'Get the IP info.
Public Sub GetIPInfo
	
	      'Grab the info from the provider.
							req.InitializeGet("http://ip-api.com/xml")
	      http.Execute(req, 1)	
								
End Sub

Public Sub GetCountryInfoByIP

	      'Grab the info from the provider.
							'Here we are reusing the code and we set
							'a different TaskID to identify it, you will
							'see the reason in the "GetIPInfo_StreamFinish" subroutine.
							req.InitializeGet("http://ip-api.com/xml")
	      http.Execute(req, 2)
							
End Sub

'Test the internet connection speed.
Public Sub SpeedTest

								'Nothing fancy here, just display the
								'WebView and load the SpeedTest page.
								IsSpeedShow = True
								
								SpeedWebView.Visible = True
								SpeedWebView.LoadUrl("http://www.fast.com")
								
End Sub

'Hide the SpeedTest/Country info screen.
Public Sub HideInfoScreen
	
	      'Again, nothing fancy, just hide the WebView
							'and clear its content.
							IsSpeedShow = False
							
							SpeedWebView.Visible = False
							SpeedWebView.LoadHtml("<html></html>")
							
End Sub

'Returns the state of the SpeedTest screen.
'True = On screen, False = Hidden.
Public Sub IsShow As Boolean
	
	      Return IsSpeedShow
							
End Sub

'Grab the info from the provider.
Private Sub ShowCountryInfo
								
								'Here we display the country info.
								'This routine triggers when we set the TaskID to 2.
								IsSpeedShow = True
								
								SpeedWebView.Visible = True
								SpeedWebView.LoadUrl("http://www.geognos.com/api/en/countries/info/" & CountryCode & ".html")
								
End Sub

'##########################
'######## Routines ########
'##########################

Private Sub MeasureSpeed_OverrideUrl(Url As String) As Boolean 'Ignore

								'We do this to prevent redirecting to the SpeedTest.net website
								'if the link it's tapped.
								If Url.Contains("speedtest.net") Then Return True

End Sub
	
Private Sub Parser_StartElement(Uri As String, Name As String, Attributes As Attributes)
	
End Sub

Private Sub Parser_EndElement(Uri As String, Name As String, Text As StringBuilder)

	       'Let's parse the XML.
								If Parser.Parents.IndexOf("query") > -1 Then
										
											If Name = "country" Then
												
												  Country = Text.ToString 			
											
		         Else If Name = "countryCode" Then
			
			           CountryCode = Text.ToString
														
											Else If Name = "region" Then
												
												  Region = Text.ToString
														
											Else If Name = "regionName" Then
												
												  RegionName = Text.ToString
											
											Else If Name = "city" Then
												
												  City = Text.ToString
														
											Else If Name = "zip" Then
												
												  ZIP = Text.ToString
														
											Else If Name = "lat" Then
												
												  Latitude = Text.ToString
														
											Else If Name = "lon" Then
												
												  Longitude = Text.ToString
														
											Else If Name = "timezone" Then
												
												  TimeZone = Text.ToString
														
											Else If Name = "isp" Then
												
												  ISP = Text.ToString
														
											Else If Name = "org" Then
												
												  Org = Text.ToString
														
											Else If Name = "as" Then
												
												  ASCode = Text.ToString
														
											Else If Name = "query" Then
												
												  IP = Text.ToString																		 			
		
		         End If											

	       End If

	       'Populate our Map with the info.
								InfoMap.Put("Country", Country)
								InfoMap.Put("CountryCode", CountryCode)
								InfoMap.Put("Region", Region)
								InfoMap.Put("RegionName", RegionName)
								InfoMap.Put("City", City)
								InfoMap.Put("ZIP", ZIP)
								InfoMap.Put("Latitude", Latitude)
								InfoMap.Put("Longitude", Longitude)
								InfoMap.Put("TimeZone", TimeZone)
								InfoMap.Put("ISP", ISP)
								InfoMap.Put("Org", Org)
								InfoMap.Put("AS", ASCode)
								InfoMap.Put("IP", IP)

End Sub

'############################
'######## Fetch Data ########
'############################

Private Sub http_ResponseSuccess(Response As OkHttpResponse, TaskId As Int)
	
	       Response.GetAsynchronously("GetIPInfo", File.OpenOutput(File.DirInternal, "Info.xml", False), True, TaskId)
	
End Sub

Private Sub http_ResponseError(Response As OkHttpResponse, Reason As String, StatusCode As Int, TaskId As Int)
	
	       If SubExists(cCallback, cEventName & "_Error") Then
											
		         CallSubDelayed2(cCallback, cEventName & "_Error", Reason)

	       End If
	
End Sub

Private Sub GetIPInfo_StreamFinish(Success As Boolean, TaskId As Int)
	
	       If Success Then

         	 InfoMap.Clear
										
										 Private InStream As InputStream
										
		         InStream = File.OpenInput(File.DirInternal, "Info.xml")
		        
										 Private TxtReader As TextReader
		        
										 TxtReader.Initialize2(InStream, "UTF-8")
		        
										 Parser.Parse2(TxtReader, "Parser")
		        
										 InStream.Close

           'Since we are reusing the parsing code (we just need the Country Code)
											'here we redirect to the "ShowCountryInfo" subroutine.
											If TaskId = 2 Then
												
												  ShowCountryInfo
														
														Return True
														
           End If
											
				       'Send the Map containing the info back to the Activity.
											If SubExists(cCallback, cEventName & "_Info") Then
														
					         CallSubDelayed2(cCallback, cEventName & "_Info", InfoMap)

				       End If
											
	       End If
	
End Sub